<template>
  <v-app class="diseaseHistory">
    <div class="diseaseHistory__title">
      <h1>История болезни</h1>
    </div>

    <!--Поиск карточки-->
    <v-text-field class="diseaseHistory__search" v-model="search" append-icon="mdi-magnify" label="Поиск.." single-line
                  hide-details></v-text-field>

    <!--Истоия болезни-->
    <v-data-table
        :headers="headers"
        :items="diseaseHistory"
        :search="search"
        sort-by="id"
        class="diseaseHistory__table"
    >

      <template #item.full_name="{ item }">{{ item.medication.user.surname }} {{ item.medication.user.name }} {{ item.medication.user.fatherName }}</template>

      <template v-slot:item.actions="{ item }">
        <v-card-text class="mr-2 routerOnPage" @click="routerOnPage(item)">Подробнее</v-card-text>
      </template>
    </v-data-table>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "DiseaseHistory",
  data() {
    return {
      diseaseHistory: [],
      medicalCard: [],
      dailyStatuses: [],
      medicalCardEditedId: -1,
      operationLogEditedIndexInList: -1,
      search: '',

      headers: [
        {
          text: 'Дата поступления',
          value: 'dateIssue',
          sortable: false
        },
        {
          text: 'Дата выписки',
          value: 'dateDischarge',
          sortable: false
        },
        {
          text: 'Фамилия',
          value: 'patient.surname',
          sortable: false
        },
        {
          text: 'Имя',
          value: 'patient.name',
          sortable: false
        },
        {
          text: 'Отчество',
          value: 'patient.fatherName',
          sortable: false
        },
        {
          text: 'Страховой полис',
          value: 'patient.insurancePolicy',
          sortable: false
        },
        {
          text: 'Адрес',
          value: 'patient.address',
          sortable: false
        },
        {
          text: 'Диагноз',
          value: 'disease.name',
          sortable: false
        },
        {
          text: 'Палата',
          value: 'ward.name',
          sortable: false
        },
        {
          text: 'Отделение',
          value: 'ward.division.name',
          sortable: false
        },
        {
          text: 'Начало лечения',
          value: 'medication.dateStart',
          sortable: false
        },
        {
          text: 'Окончание лечения',
          value: 'medication.dateFinish',
          sortable: false
        },
        {
          text: 'Лечащий врач',
          value: 'full_name',
          sortable: false
        },
        {
          text: 'Статус оплаты',
          value: 'isPaid',
          sortable: false
        },
        {
          text: 'Узнать подробнее',
          value: 'actions',
          sortable: false
        }
      ]
    }
  },

  mounted() {
    this.fetchDisease()
  },

  methods: {
    async fetchDisease() {
      axios
          .get(this.$root.globalVar + '/medical_card')
          .then(response => {
            this.diseaseHistory = response.data
            console.log(this.diseaseHistory)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
            console.log(this.diseaseHistory)
          })
    },

    async fetchPatientDisease(id){
      axios
          .get(this.$root.globalVar + '/daily_status/byPatient/' + id)
          .then(response => this.dailyStatuses = response.data)
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    routerOnPage(item) {
      console.log(item)
      this.fetchPatientDisease(item.id)
      this.$router.push('/patient_disease_history/' + item.id)
    }
  }
}
</script>

<style lang="scss" scoped>
.diseaseHistory {
  &__title {
    margin: 60px 0 30px 0;
    text-align: center;
  }

  &__table {
    margin: 0 auto;
  }

  &__search {
    width: 50%;
    margin: 0 auto;
  }
}

.v-text-field {
  flex: 0.2 0 !important;
  margin-top: 30px;
}

.routerOnPage {
  &:hover {
    cursor: pointer;
  }
}
</style>